#ifndef PLUMB_FD_H
#define PLUMB_FD_H

#include "process.h"

/* close an fd, make sure eof is sent to the other side of the pipe
   on it and kill the process if needed */
void fd_close(fd_t *fd);

/* write data to an fd; return -1 on error
  fd refers to the either side of the pipe, always the ->to fd will be written */
int fd_write(fd_t *fd, const char *data, int len);

/* Low level write to an fd backed with a real sockfd */
int fd_write_sockfd(fd_t *fd, int sockfd, const char *data, int len);

/* back-promote block (or release of block) from a sink fd */
void back_block(fd_t *sink, int is_blocking);

/* set an fd paused - if it is a sink, it may block its source through the pipe */
void fd_pause(fd_t *fd, int is_paused);

/* recalculate when to set POLLIN  on a source (only for unpaused, unblocked sources) */
void fd_rp_source_poll(fd_t *src);

/* try to flush rb */
void fd_flush_rb(fd_t *src);

/* clear the outgoing buffer (discarding anything unsent) */
void fd_clear_buff(fd_t *fd);

#endif
