#include <stdio.h>

void help(const char *prg)
{
	printf("plumb - the pipe shell\n");
	printf("Usage: %s [-I dir] [-f scriptfn] [-v vn val] [script]\n", prg);
	printf("  -I dir         add dir to the include search list\n");
	printf("  -f scriptfn    load script from file scriptfn\n");
	printf("  -v vn val      set the value of plumb variable vn to val\n");
	printf("  -d             debug dump internal operations to stderr\n");
	printf("  script         plumb script (in-line)\n");
	printf("\n");
	printf("All options may be specified multiple times and they are evaluated\n");
	printf("in order. Each -f and in-line script is a separate transaction and\n");
	printf("has to be closed (last statement must be terminated by a semicolon or\n");
	printf("newline).\n");
	printf("\n");
	printf("Examples:\n");
	printf(" print date on stdout and exit\n");
	printf("   %s '{date} | env:1;'\n", prg);
	printf(" run proc1 and proc2 in a '69' setup:\n");
	printf("   %s 'p1={proc1} | {proc2} | p1:0;'\n", prg);
	printf(" 69 setup, also log both streams to files using hubs\n");
	printf("   %s '\n", prg);
	printf("     h1=[hub] | {proc1} | h2=[hub] | {proc2} | h1:*\n");
	printf("     h1:* | [open proc1_in.log]\n");
	printf("     h2:* | [open proc2_in.log]\n'\n");
	printf("\n");
}
