/* for exposing plumb_error() */
#include "process.h"
#include "diagnostic.h"

/* allocate a new fd struct from the central array */
fd_t *fd_alloc(void);

/* add poll events for an fd (register if not yet polled) */
void fd_add_watch(fd_t *fd, int events);

/* del poll events for an fd (register if not yet polled) */
void fd_del_watch(fd_t *fd, int events);

/* return what fd is watched for, masked with events */
int fd_query_watch(fd_t *fd, int events);

/* set the socket for an fd being watched */
void fd_set_socket(fd_t *fd, P_net_socket sockfd);

/* return the socket of an fd, or P_NET_INVALID_SOCKET if not available */
P_net_socket fd_query_socket(fd_t *fd);

/* make sure all real processes are killed */
void plumb_stop_RPs(void);

/* make a full shutdown procedure an exit with plumb_main_retval */
extern int plumb_main_retval;
void plumb_exit(void);

/* search fn on default and user-provided library paths and return full path
   for the first match or NULL on no match */
char *plumb_lib_search(const char *fn);


extern int plumb_stick;
extern int plumb_shutdown; /* non-zero during shutting down */

#define plumb_sticky_started()   (plumb_stick++)
#define plumb_sticky_died()      (plumb_stick--)
