#ifndef PLUMB_VAR_H
#define PLUMB_VAR_H
typedef enum {
	VAR_NOFLUSH = 1           /* discard instead of copying to global scope */
} var_flag_t;

typedef struct var_s {
	int flags;
	int vlen;
	char value[1];
} var_t;

/* returns var_t so flag can be set */
var_t *var_set(transaction_t *tx, const char *name, const char *value);

const char *var_get(transaction_t *tx, const char *name);

/* remove a variable from a transaction if tx is not NULL; remove it
   from global if tx is NULL */
void var_del(transaction_t *tx,const char *name);

/* copy all transaction variables to the global namespace; remove them
   from the transaction if destroy is 1 */
void var_flush(transaction_t *tx, int destroy);

/* uninitialize variables of a transaction or global space if tx is NULL */
void var_uninit(transaction_t *tx);
#endif
