BEGIN {
	q="\""
	tab="\t"
	fmt="png"
	clr_stopped = q "#ffaaaa" q
	clr_paused = q "#ffffaa" q
	oinc()
	split(exclude, A, ",")
	for(e in A)
		EXCLUDE[A[e]]++
}

function oinc()
{
	octr++
	ofile="plumbviz_" octr ".gv"
	gfile="plumbviz_" octr
}

function draw_proc(id, name, sinks, args, srcs, extra)
{
	if (extra != "")
		extra = extra ", "
	print tab q id q " [" extra " label=\"<name> " name " |{{ " sinks "}| { " args " } |{ " srcs "}}\"]" > ofile
}

function legend(    sinks)
{
	print "subgraph cluster_legend {" >ofile
	print "label=legend;" >ofile

	draw_proc("l1", "non-sticky process",  "|",  "(frame color)",  "|", "");
	draw_proc("l2", "sticky process",  "|",  "(frame color)",  "|", "color=blue");



	print "	subgraph cluster_legend_implicit {"> ofile
	print "		label=\"(grey cluster bakcground) \\n implicit processes\";"> ofile
	print "		style=filled;"> ofile
	print "		color=lightgrey;"> ofile
	draw_proc("l3", "process",  "|",  "",  "|", "");
	print "	}"> ofile

	create_cluster("cluster_legend_transaction", "(cluster background)\\ntransaction", 1)
	print "	subgraph cluster_legend_transaction {"> ofile
	draw_proc("lt", "process",  "|",  "",  "|", "");
	print "	}"> ofile


	draw_proc("l5", "running",  "|",  "(bgcolor)",  "|", "");
	draw_proc("l6", "paused",   "|",  "(bgcolor)",  "|", "style=filled, fillcolor=" clr_paused);
	draw_proc("l7", "stopped",  "|",  "(bgcolor)",  "|", "style=filled, fillcolor=" clr_stopped);

	print "l5->l6 [style=invis]" >ofile
	print "l6->l7 [style=invis]" >ofile

	draw_proc("l4", "process ID",  "sink fd1 [socket1] | sink fd2 [socket2]",  "\\{real\\} or [virtual] \\n arg1 \\n arg2 \\n ...",  "source fd3 [socket3] | source fd4 [socket4]", "");

	print "fd1 [label=\"source_fd\"]">ofile
	print "fd2 [label=\"sink_fd\"]">ofile
	print "fd1->fd2 [label=pipe] ">ofile

	print "l1->l2 [style=invis]" >ofile
	print "l2->l3 [style=invis]" >ofile
	print "l3->lt [style=invis]" >ofile
	print "fd2->l4 [style=invis]" >ofile


	print "}"  > ofile
}

/^### start of plumb internals$/ {
	ok = 1
	print "digraph plumb {" > ofile
	print "node [shape=record];" > ofile
	print "rankdir=LR;" > ofile
	print "ranksep=1;" > ofile
	print "nodesep=1" > ofile
	if (!omit_legend)
		legend()
	print "subgraph cluster_main {" >ofile
	print "	color=white;" > ofile
	print "	subgraph cluster_envsource {"> ofile
	print "		label=environment;"> ofile
	print "		style=filled;"> ofile
	print "		color=lightgrey;"> ofile
	print "	}"> ofile
	print "	subgraph cluster_envsink {"> ofile
	print "		label=environment;"> ofile
	print "		style=filled;"> ofile
	print "		color=lightgrey;"> ofile
	print "	}"> ofile
	print "	subgraph cluster_internal {"> ofile
	print "		label=internal;"> ofile
	print "		style=filled;"> ofile
	print "		color=lightgrey;"> ofile
	print "	}"> ofile
	print "" > ofile
}

/^### end of plumb internals$/ {
	ok = 0
	proc_flush()
	if (dump_label != "") {
		print "fontsize=42;" > ofile
		print "label=" q dump_label q ";" > ofile
	}
	print "}"  > ofile
	print "}"  > ofile
	fflush(ofile)
	system("dot -T" fmt " " ofile " >" gfile "." fmt)
	oinc()
	delete(WATCH)
	delete(CLUSTER_CREATED)
	dump_label=""
}

/^# label / {
	dump_label = $0
	sub("^# label ", "", dump_label)
}

(!ok) { next }

function create_cluster(id, label,    nohide)
{
	if (id in CLUSTER_CREATED)
		return
	print tab "subgraph " id " {" > ofile
	print tab tab "label=" q label q ";" > ofile
	print tab tab "color=bisque3;" > ofile
	print tab tab "style=filled;" > ofile
	print tab "}" > ofile

# hide original virtual process
	if (!nohide)
		print	tab q id q "[style=invisible]" > ofile
	CLUSTER_CREATED[id] = 1
}

function proc_flush(       qid,sinks,args,srcs,txname,txlabel,clust,procid)
{


	if (PROC["id"] != "") {

		procid = PROC["id"]
		if ((procid != "_env") && (procid in SHADOW_R2V))
			procid = SHADOW_R2V[procid]

		if (procid == "env")
			return;

		if (procid in EXCLUDE)
			return

		if (PROC["cmd"] in EXCLUDE)
			return

		sinks=PROC["sink"]
		srcs=PROC["source"]
		args=PROC["arg"]

# _env needs split version
		if (procid == "_env") {
			if ("env" in EXCLUDE)
				return
			print tab "subgraph cluster_envsource {"> ofile
			print tab tab q "_env_src"  q  " [label=\"<name> env (sources)|{ { " args " } |{ " srcs "}}\"]" > ofile
			print tab "}"> ofile
			print tab "subgraph cluster_envsink {"> ofile
			print tab tab q "_env_sink" q  " [label=\"<name> env (sinks)|{{ " sinks "}| { " args " }}\"]" > ofile
			print tab "}"> ofile
		}
		else {
			if (PROC["prop/sticky"] == "yes")
				clr = "color=blue, "
			else
				clr = ""
			if (PROC["state"] == "stopped")
				clr = clr "style=filled, fillcolor=" clr_stopped ", "
			else if (PROC["state"] == "paused")
				clr = clr "style=filled, fillcolor=" clr_paused ", "
			
			if (PROC["transaction"] == "plumb_stdscript") {
				if ("plumb_stdscript" in EXCLUDE)
					return
				print tab "subgraph cluster_internal {" > ofile
				printf(tab) > ofile
				clust=1
			}
			else if (PROC["transaction"] != "<unknown>") {
				txname  = PROC["transaction"]
				txlabel = PROC["transaction"]

				if (txname in EXCLUDE)
					return

				gsub("[^A-Za-z0-9]", "_", txname);
				txname = "cluster_" txname
				create_cluster(txname, txlabel, 1)
				print tab "subgraph " txname " {" > ofile
				printf(tab) > ofile
				clust=1
			}
			else
				clust = 0;

			print tab q procid q  " [" clr " label=\"<name> " procid "|{{ " sinks "}| { " args " } |{ " srcs "}}\"]" > ofile
			if (clust)
				print tab "}" > ofile
		}
	}
	delete PROC
}

function arg(       a)
{
	a = $0
	sub("^proc/arg/[0-9]*[ \t]*", "", a)
	gsub("\"", "\\\"", a)
	return a
}

/^proc / {
	proc_flush()
	PROC["id"] = $2
	PROC["type"] = $3
}

/^proc\/fd\/[0-9]*/ {
	fd = $1
	sub("^proc/fd/", "", fd)
	fdname=PROC["id"] ":" fd
	if (fdname in WATCH)
		watch = "\\n" WATCH[fdname]
	else
		watch = ""
	new = "<" fd "> " fd " [" $4 "]" watch
	if (PROC[$2] == "")
		PROC[$2] = new
	else
		PROC[$2] = PROC[$2] "|" new
}

/^proc\/arg\/0 / {

	if (PROC["type"] == "real")
		PROC["arg"] = "\\{"  arg() "\\}"
	else
		PROC["arg"] = "\\["  arg() "\\]"
	PROC["cmd"] = PROC["arg"]
	next
}

/^proc\/arg\/[0-9]*/ {
	PROC["arg"] = PROC["arg"]  "\\n" arg()
}

/^proc\/property\// {
	prop = $1
	sub("^proc/property/", "prop/", prop)
	PROC[prop] = $2
}

/^proc\/state/ {
	PROC["state"] = $2
}

/^proc\/transaction/ {
	txname = $0
	sub("^proc/transaction[ \t]*", "", txname)
	PROC["transaction"] = txname
}

/^proc\/shadow_of/ {
	SHADOW_V2R[$2] = PROC["id"]
	SHADOW_R2V[PROC["id"]] = $2
}

function _env(fd, dir    ,proc,fdnum)
{
	proc  = fd
	fdnum = fd
	sub(":.*", "", proc)
	sub(".*:", "", fdnum)

	if (proc == "_env") {
		if ("env" in EXCLUDE)
			return ""
		return q proc "_" dir q ":" fdnum;
	}

	if (proc in EXCLUDE)
		return ""

	if (proc in SHADOW_R2V)
		proc = SHADOW_R2V[proc]

	return q proc q ":" fdnum;
}

/^pipe\// {
	id = $1
	sub("^pipe/", "", id)

	from = _env($2, "src")
	to = _env($4, "sink")
	if ((from == "") && (to == ""))
		next
	print tab from  " -> " to > ofile
}

/^watch\// {
	WATCH[$2] = $3
}
